/*-
 * ~~~~~~licensing~~~~~~
 * application-api
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.integration.applications;

import java.util.List;

import ru.entaxy.platform.integration.applications.exceptions.ProjectVersionException;

public interface EntaxyApplicationProject {
    String getName();

    String getGroup();

    ApplicationStorage getStorage();

    void save();

    void disgard();

    List<EntaxyApplicationProjectVersion> getVersions();

    EntaxyApplicationProjectVersion getLatestVersion();

    EntaxyApplicationProjectVersion getVersion(String version);

    EntaxyApplicationProjectVersion createVersion(String version) throws ProjectVersionException;

    EntaxyApplicationProjectVersion createVersion(String version, String fromVersion) throws ProjectVersionException;

    void removeVersion(String version);

    ApplicationProjectInfo getInfo();
}
