/*-
 * ~~~~~~licensing~~~~~~
 * application-impl
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.integration.applications.impl.jar;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Iterator;

import org.apache.commons.io.FileUtils;

public class FolderBasedJarBuilder extends JarBuilder {

    File rootFolder;

    public FolderBasedJarBuilder(File targetFile, File rootFolder) {
        super(targetFile);
        this.rootFolder = rootFolder;
    }

    public void loadFiles() throws FileNotFoundException, IOException, IllegalStateException {
        if (Status.FINALIZED.equals(status))
            throw new IllegalStateException("JarBuilder is finalized");
        if (Status.NEW.equals(status))
            open();

        Iterator<File> iterator = FileUtils.iterateFiles(rootFolder, null, true);
        while (iterator.hasNext()) {
            File file = iterator.next();
            String name = file.getAbsolutePath().replace(rootFolder.getAbsolutePath(), "").replace('\\', '/');
            if (name.startsWith("/"))
                name = name.substring(1);
            addFile(file, name);
        }

    }

}
