/*-
 * ~~~~~~licensing~~~~~~
 * route-management
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.management.route;

import ru.entaxy.esb.platform.base.management.core.ManagementCore;
import ru.entaxy.esb.platform.base.management.core.api.MBeanAnnotated;
import ru.entaxy.esb.platform.base.management.core.api.MBeanExportPolicy;
import ru.entaxy.esb.platform.base.management.core.api.Operation;

@MBeanAnnotated(policy = MBeanExportPolicy.ANNOTATED_ONLY)
public interface RouteComponentLibrariesMBean {

    String ROUTE_COMPONENT_LIBRARIES_KEY = "util";
    String ROUTE_COMPONENT_LIBRARIES_KEY_VALUE = "route-component-libraries";

    String JMX_OBJECT_NAME = ManagementCore.Q_PLATFORM_S + ","
            + RouteComponentLibrariesMBean.ROUTE_COMPONENT_LIBRARIES_KEY + "="
            + RouteComponentLibrariesMBean.ROUTE_COMPONENT_LIBRARIES_KEY_VALUE;

    @Operation(desc = "Gets all tag descriptors")
    String readAllTagDescriptors() throws Exception;
}
