/*-
 * ~~~~~~licensing~~~~~~
 * route-management
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.management.route.impl;

import javax.management.NotCompliantMBeanException;

import ru.entaxy.esb.platform.base.management.core.api.EntaxyRuntimeTyped;
import ru.entaxy.platform.core.management.object.EntaxyRuntimeItemMBean;
import ru.entaxy.platform.core.management.object.ObjectMBean;
import ru.entaxy.platform.core.management.object.factory.AbstractObjectMBean;
import ru.entaxy.platform.core.management.route.RoutesMBean;
import ru.entaxy.platform.objects.runtime.EntaxyRuntimeObject;

@EntaxyRuntimeTyped(name = RoutesMBean.RUNTIME_TYPE)
@ObjectMBean(subQualifierName = EntaxyRuntimeItemMBean.JMX_SUBQUALIFIER_AUTO)
public class RoutesMBeanImpl extends AbstractObjectMBean<RoutesMBean> implements RoutesMBean {

    protected RoutesMBeanImpl(EntaxyRuntimeObject entaxyRuntimeObject)
            throws NotCompliantMBeanException {
        super(RoutesMBean.class, entaxyRuntimeObject);
    }

    @Override
    public String getJMXSubQualifierValue() {
        return RoutesMBean.JMX_SUBQUALIFIER_VALUE;
    }

    @Override
    public String getId() {
        return super.getId().concat("_routes");
    }

    @Override
    public String getDisplayName() {
        return "routes";
    }

    @Override
    public String getRuntimeType() {
        return RoutesMBean.super.getRuntimeType();
    }
}
