/*-
 * ~~~~~~licensing~~~~~~
 * object-runtime-shell
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.objects.runtime.shell;

import org.apache.karaf.shell.api.action.Action;
import org.apache.karaf.shell.api.action.Argument;
import org.apache.karaf.shell.api.action.Command;
import org.apache.karaf.shell.api.action.lifecycle.Service;
import org.osgi.framework.Filter;
import org.osgi.framework.FrameworkUtil;

import ru.entaxy.platform.base.support.karaf.shell.ShellTableExt;
import ru.entaxy.platform.objects.runtime.EntaxyRuntimeObject;

@Service
@Command(name = "find-objects", scope = EntaxyRuntimeObjectServiceSupport.OBJECTS_SCOPE)
public class ObjectFind extends EntaxyRuntimeObjectServiceSupport implements Action {

    @Argument(index = 0)
    String filter;

    @Override
    public Object execute() throws Exception {

        Filter odgiFilter = FrameworkUtil.createFilter(filter);

        ShellTableExt shellTable = new ShellTableExt();
        shellTable.column("Id");
        shellTable.column("Type");

        for (EntaxyRuntimeObject obj : objectService.findObjects(odgiFilter))
            shellTable.addRow().addContent(
                    obj.getId(), obj.getType());

        shellTable.print(System.out);

        return null;
    }

}
