<?xml version="1.0" encoding="UTF-8"?>
<!--
  ~~~~~~licensing~~~~~~
  route-producing
  ==========
  Copyright (C) 2020 - 2025 EmDev LLC
  ==========
  You may not use this file except in accordance with the License Terms of the Copyright
  Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
  rights to the Software and any copies are the property of the Copyright Holder. Unless
  it is explicitly allowed the Copyright Holder, the User is prohibited from using the
  Software for commercial purposes to provide services to third parties.
  
  The Copyright Holder hereby declares that the Software is provided on an "AS IS".
  Under no circumstances does the Copyright Holder guarantee or promise that the
  Software provided by him will be suitable or not suitable for the specific purposes
  of the User, that the Software will meet all commercial and personal subjective
  expectations of the User, that the Software will work properly, without technical
  errors, quickly and uninterruptedly.
  
  Under no circumstances shall the Copyright Holder or its Affiliates is not liable
  to the User for any direct or indirect losses of the User, his expenses or actual
  damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
  or damage to data, property, etc.
  ~~~~~~/licensing~~~~~~
  -->

<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2005/xpath-functions"  xmlns:entaxy="http://www.entaxy.ru/schemas/1.0"  xmlns:m="http://www.entaxy.ru/schemas/entaxy-mediators/1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:blueprint="http://www.osgi.org/xmlns/blueprint/v1.0.0">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	
	<xsl:param name="context.type" select="'entaxy.runtime.service'" />
	<xsl:param name="context.fieldName" select="'serviceField01'" />
	<xsl:param name="context.objectId" select="'service-00'" />
	
	<xsl:param name="serviceType" select="'UNKNOWN'" />
	
	<xsl:template match="//entaxy:object-route" exclude-result-prefixes="fn xs">
		<xsl:choose>
			<xsl:when test="$context.type = 'entaxy.runtime.service'">
				<!-- service route fields processing -->
				<xsl:choose>
					<xsl:when test="$context.fieldName = 'operationRouter'">
						<route xmlns="http://camel.apache.org/schema/blueprint">
							<xsl:attribute name="id"><xsl:value-of select="concat($context.objectId, '-operation-router')" /></xsl:attribute>
							<xsl:variable name="uri">
								<xsl:text>direct:</xsl:text><xsl:value-of select="$context.objectId" /><xsl:text>-operation-router</xsl:text>
							</xsl:variable>
							<xsl:text>&#10;</xsl:text>
							<xsl:comment>generated from 'entaxy:object-route' for <xsl:value-of select="$context.objectId"/>:<xsl:value-of select="$context.type"/>/<xsl:value-of select="$context.fieldName"/></xsl:comment>
							<from>
								<xsl:attribute name="uri" select="$uri" />
							</from>
							<xsl:apply-templates select="node()" />								
						</route>
					</xsl:when>
					<xsl:otherwise>
							<route xmlns="http://camel.apache.org/schema/blueprint">
								<xsl:apply-templates select="node()|@*" />
							</route>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			
			<xsl:otherwise>
				<route xmlns="http://camel.apache.org/schema/blueprint">
					<xsl:apply-templates select="node()|@*" />
				</route>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
	<xsl:template match="/">
		<xsl:apply-templates select="child::node()" />
	</xsl:template>
	
	<xsl:template name="default-copy" match="node()|@*" exclude-result-prefixes="fn xs xsi">
		<xsl:copy>
			<xsl:apply-templates select="node()|@*" />
		</xsl:copy>
	</xsl:template>		
	
</xsl:stylesheet>
