[#ftl attributes={"generated.type":"blueprint.fragment"}]
<!--
	[#list .data_model?keys as key]
	  [=key] = [#if .data_model[key]?? && .data_model[key]?is_string][=.data_model[key]][/#if]
	[/#list]
-->

[#if oauthEnable?? && oauthEnable?boolean == true]
	[#if !properties.oauthUrlRefresh?? || properties.oauthUrlRefresh==""]
		[#assign oauthUrlRefresh = properties.oauthUrlToken!]
	[#else]
		[#assign oauthUrlRefresh = properties.oauthUrlRefresh!]
	[/#if]
	[#assign oauthUrlRefresh = oauthUrlRefresh + "?throwExceptionOnFailure=false"]
	[#assign expiredPolicyRoute = "direct-vm:oauth-refresh-expired-" + ownerId]
	
	[#if !oauthStatic?? || oauthStatic?boolean == false]
		[#if properties.oauthRefreshPolicy?? && properties.oauthRefreshPolicy == "expired"]
	<reference id="lockService" interface="ru.entaxy.platform.core.support.runtime.service.ServiceHolder" 
	filter="(internalType=org.jgroups.blocks.locking.LockService)" availability="mandatory"/>
	
	<bean id="master.clusterService" class="ru.entaxy.platform.core.support.runtime.cluster.JGroupsLockClusterService">
		<argument index="0" ref="lockService" />
		<property name="id" value="Connector"/>
	</bean>
	
	<bean xmlns="http://www.osgi.org/xmlns/blueprint/v1.0.0" 
		id="hazelcastCallbackEntryExpiredListener" class="ru.entaxy.platform.core.support.runtime.hazelcast.HazelcastCallbackEntryExpiredListener">
		 <argument ref="[=properties.ownerContextId!]"/>
		 <argument value="[=expiredPolicyRoute]"/>
	</bean>
	
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-activate-listeners">
		<from uri="master:[=ownerId]-hazelcast:timer:[=ownerId]-listener?repeatCount=1"/>
		<bean ref="hazelcastHelper" method="activateListeners" />
	</route>
		[/#if]
	<reference xmlns="http://www.osgi.org/xmlns/blueprint/v1.0.0"
			id="hazelcastInstance" interface="com.hazelcast.core.HazelcastInstance" 
			timeout="30000"/>
	<bean xmlns="http://www.osgi.org/xmlns/blueprint/v1.0.0" 
			id="hazelcastHelper" class="ru.entaxy.platform.core.support.runtime.hazelcast.HazelcastHelper"
			destroy-method="destroy">
		<argument ref="hazelcastInstance"/>
		<argument value="oauth_[=ownerId]"/>
		[#if properties.oauthRefreshPolicy?? && properties.oauthRefreshPolicy == "expired"]
		 <argument>
			<list value-type="com.hazelcast.map.listener.MapListener">
				<ref component-id="hazelcastCallbackEntryExpiredListener"/>
			</list>
		</argument>
		<argument value="false"/>
		[/#if]
	</bean>
	[/#if]
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-prepare" streamCache="true">
		<from uri="direct:oauth-prepare" />
		<setProperty name="NTX_bodyHolder">
			<simple>${body}</simple>
		</setProperty>
	[#if oauthStatic?? && oauthStatic?boolean == true]
		<setProperty name="oauthToken">
			<constant>[=properties.oauthStaticToken]</constant>
		</setProperty>
		<!--set outgoing header-->
		<to uri="direct:set-outgoing-header" />
	[#else]
		<!--get from hazelcast-->
		<to uri="direct:get-stored-token" />
		
		<choice>
			<when>
				<simple>${exchangeProperty.oauthToken} == null || ${exchangeProperty.oauthToken.length()} == 0</simple>
				<to uri="direct:get-new-token" />
				<!--store to hazelcast with ttl-->
				<to uri="direct:store-token" />
			</when>
			<otherwise>
				<log message="OAUTH: token taken from cache" loggingLevel="DEBUG"/>
			</otherwise>
		</choice>
		
		<log message="OAUTH: properties ${exchange.getProperties()}" loggingLevel="TRACE"/>
		<!--set outgoing header-->
		<to uri="direct:set-outgoing-header" />
	[/#if]
		<setBody>
			<simple>${exchangeProperty.NTX_bodyHolder}</simple>
		</setBody>
		<removeProperty propertyName="NTX_bodyHolder"/>
	</route>
	
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-set-outgoing-header">
		<from uri="direct:set-outgoing-header"/>
		[#if oauthBase64?? && oauthBase64?boolean == true]
		<setBody>
			<simple>${exchangeProperty.oauthToken}</simple>
		</setBody>
		<marshal>
			<base64 lineSeparator=""/>
		</marshal>
		<setProperty name="oauthToken">
			<simple>${body}</simple>
		</setProperty>
		[/#if]
		<setHeader name="[=properties.oauthHeader]">
			<simple>[=properties.oauthHeaderPattern]</simple>
		</setHeader>
	</route>
	
	[#if !oauthStatic?? || oauthStatic?boolean == false]
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-get-new-token">
		<from uri="direct:get-new-token" />
		<log message="OAUTH: get new token" loggingLevel="DEBUG"/>
		<setProperty name="oauthClientId">
			<constant>[=properties.oauthClientId!]</constant>
		</setProperty>
		<setProperty name="oauthClientSecret">
			<constant>[=properties.oauthClientSecret!]</constant>
		</setProperty>
		<setProperty name="oauthType">
			<constant>[=properties.oauthType]</constant>
		</setProperty>
		<setProperty name="oauthUsername">
			<constant>[=properties.oauthUsername!]</constant>
		</setProperty>
		<setProperty name="oauthPassword">
			<constant>[=properties.oauthPassword!]</constant>
		</setProperty>
		
		<to uri="direct:oauth-pre-token" />

		<to uri="[=properties.oauthUrlToken]" />
		
		<convertBodyTo type="String"/>
		
		<to uri="direct:oauth-parse-token" />
	</route>
	
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-refresh" streamCache="true">
		<from uri="direct:oauth-refresh" />
		<log message="OAUTH: refresh token [=ownerId]" loggingLevel="DEBUG"/>
		<choice>
			<when>
				<simple>${exchangeProperty.oauthRefreshToken} != null &amp;&amp; ${exchangeProperty.oauthRefreshToken.length()} &gt; 0</simple>
				<log message="OAUTH: refresh with oauthRefreshToken" loggingLevel="DEBUG"/>
				<setProperty name="oauthType">
					<constant>refresh_token</constant>
				</setProperty>
				<setProperty name="oauthClientId">
					<constant>[=properties.oauthClientId]</constant>
				</setProperty>
				<setProperty name="oauthClientSecret">
					<constant>[=properties.oauthClientSecret]</constant>
				</setProperty>

				<to uri="direct:oauth-pre-refresh" />
				<to uri="[=oauthUrlRefresh]" />
				<choice>
					<when>
						<simple>${header.CamelHttpResponseCode} == 200</simple>
						<convertBodyTo type="String"/>
						<to uri="direct:oauth-parse-token" />
					</when>
					<otherwise>
						<to uri="direct:get-new-token" />
					</otherwise>
				</choice>
			</when>
			<otherwise>
				<to uri="direct:get-new-token" />
			</otherwise>
		</choice>
		<!--store to hazelcast with ttl-->
		<to uri="direct:store-token" />
	</route>
	
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-get-stored-token">
		<from uri="direct:get-stored-token" />
		<!--get from cache-->
		<setProperty name="oauthKey" >
			<constant>oauth_[=ownerId]</constant>
		</setProperty>
		<bean ref="hazelcastHelper" method="get(${exchangeProperty.oauthKey})" />
		<log message="OAUTH: get hazelcast ${body}" loggingLevel="TRACE"/>
		<choice>
			<when>
				<simple>${body} != null &amp;&amp; ${body.length()} &gt; 0</simple>
				<doTry>
				<to uri="direct:oauth-parse-token" />
				<doCatch>
					<exception>java.lang.Exception</exception>
					<log message="OAUTH: get hazelcast ERROR ${exception.message}" />
					<log message="OAUTH: get hazelcast ERROR ${exception.stacktrace}" loggingLevel="DEBUG"/>
				</doCatch>
				</doTry>
			</when>
		</choice>
	</route>
	
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-store-token">
		<from uri="direct:store-token" />
		<!--set to cache-->
		<setProperty name="oauthKey" >
			<constant>oauth_[=ownerId]</constant>
		</setProperty>
		<log message="OAUTH: put hazelcast ${body}" loggingLevel="TRACE"/>
	[#if properties.oauthRefreshPolicy?? && properties.oauthRefreshPolicy == "expired"]
		<choice>
			<when>
				<simple>${exchangeProperty.oauthExpiresIn} != null</simple>
				<setProperty name="ttl">
					<ognl>properties['oauthExpiresIn']-[=properties.oauthRequestBeforehand]</ognl>
				</setProperty>
				
				<bean ref="hazelcastHelper" method="put(${exchangeProperty.oauthKey}, ${body}, ${exchangeProperty.ttl})" />
			</when>
			<otherwise>
				<bean ref="hazelcastHelper" method="put(${exchangeProperty.oauthKey}, ${body})" />
			</otherwise>
		</choice>
	[#else]
		<bean ref="hazelcastHelper" method="put(${exchangeProperty.oauthKey}, ${body})" />
	[/#if]
	</route>
	
	[#if properties.oauthRefreshPolicy?? && properties.oauthRefreshPolicy == "expired"]
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-refresh-expired">
		<from uri="[=expiredPolicyRoute]" />
		<log message="OAUTH: expired policy ${body}" loggingLevel="DEBUG"/>
		<setProperty name="oauthKey" >
			<constant>oauth_[=ownerId]</constant>
		</setProperty>
		<choice>
			<when>
				<simple>${body.class.getName().contains("EntryEvent")} &amp;&amp; ${body.key} == ${exchangeProperty.oauthKey}</simple>
				<setBody>
					<simple>${body.oldValue}</simple>
				</setBody>
				<to uri="direct:oauth-parse-token" />
				<to uri="direct:oauth-refresh" />
			</when>
		</choice>
	</route>
	[#elseif properties.oauthRefreshPolicy?? && properties.oauthRefreshPolicy == "timer"
				&& oauthRefreshTimer?? && oauthRefreshTimer != ""]
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-refresh-timer">
		<from uri="timer:oauth-refresh-[=ownerId]?period=[=oauthRefreshTimer]" />
		<log message="OAUTH: timer policy ${body}" loggingLevel="DEBUG"/>
		<!--get from hazelcast-->
		<to uri="direct:get-stored-token" />
		<to uri="direct:oauth-refresh" />
	</route>
	[#elseif properties.oauthRefreshPolicy?? && properties.oauthRefreshPolicy == "error" 
				&& oauthErrorCode?? && oauthErrorCode != ""]
	<route xmlns="http://camel.apache.org/schema/blueprint" id="oauth-refresh-error">
		<from uri="direct:oauth-refresh-error" />
		<log message="OAUTH: error refresh policy checked statuses: [=oauthErrorCode]" loggingLevel="DEBUG"/>
		
		<setProperty name="errorStatuses">
			<constant>[=oauthErrorCode]</constant>
		</setProperty>
		<setProperty name="oauthRefreshed">
			<simple resultType="boolean">false</simple>
		</setProperty>
		<choice>
			<when>
				<simple>${exchangeProperty.errorStatuses.contains(${header.CamelHttpResponseCode})}</simple>
				<to uri="direct:get-stored-token" />
				<to uri="direct:oauth-refresh" />
				<!--set outgoing header-->
				<to uri="direct:set-outgoing-header" />
				<setProperty name="oauthRefreshed">
					<simple resultType="boolean">true</simple>
				</setProperty>
			</when>
		</choice>
	</route>
	[/#if]
	
	[/#if]
		
[/#if]
