[#ftl attributes={"generated.type":"blueprint"}]
<blueprint xmlns="http://www.osgi.org/xmlns/blueprint/v1.0.0"
           xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
           xmlns:cm="http://aries.apache.org/blueprint/xmlns/blueprint-cm/v1.1.0"
           xmlns:camelcxf="http://camel.apache.org/schema/blueprint/cxf"
           xmlns:cxf="http://cxf.apache.org/blueprint/core"
           xmlns:[=objectId]="[=properties.serviceNamespace]"
           xsi:schemaLocation="
             http://www.osgi.org/xmlns/blueprint/v1.0.0 https://www.osgi.org/xmlns/blueprint/v1.0.0/blueprint.xsd
             http://cxf.apache.org/blueprint/core http://cxf.apache.org/schemas/blueprint/core.xsd
             ">
[#import "templates:object-commons/common-utils.ftl" as utils]
[#include "customObjectReferences.ftl" ]
<!-- xmlns:soap-type="http://www.entaxy.ru/ExchangeTypes/1.0" -->
<!-- 

	factoryId: wsdl-based-soap-service-public
	factoryType: entaxy.runtime.service
	outputType: init 
	properties:
	[#list properties?keys as key]
		[=key]
	[/#list]
 -->
[#if schemaValidationEnabled?? && schemaValidationEnabled?is_boolean]
	[#assign schemaValidationEnabled = schemaValidationEnabled?then("BOTH","NONE")]
[/#if]
	<camelcxf:cxfEndpoint id="[=objectId]-cxf-endpoint"
                          address="[=properties.address]"
                          endpointName="[=objectId]:[=properties.port]"
                          serviceName="[=objectId]:[=properties.serviceName]"
                          wsdlURL="entaxy-resource://[=properties.schemaUrl?replace(":", "/")]">
        <camelcxf:properties>
            <entry key="dataFormat" value="[=properties.dataFormat]"/>
            <entry key="mtom-enabled" value="[=properties.mtomEnabled?c]"/>
            <entry key="schema-validation-enabled" value="[=properties.schemaValidationEnabled!"NONE"]"/>
            [#if properties.authUsername?? && properties.authPassword??]
            <entry key="username" value="[=properties.authUsername]"/>
            <entry key="password" value="[=properties.authPassword]"/>
            [/#if]
        </camelcxf:properties>
    </camelcxf:cxfEndpoint>

    <camelContext id="soap-client-[=objectId]-context" xmlns="http://camel.apache.org/schema/blueprint"
                  errorHandlerRef="commonErrorHandler">

        <route id="error_from_cxf">
            <from uri="direct:error_from_cxf"/>
            <log message="cxf message: ${body}" loggingLevel="DEBUG"/>
            <log message="headers: ${headers}\n" loggingLevel="DEBUG"/>
            <to uri="direct-vm:cxfErrorEndpoint"/>
        </route>

        <route id="[=objectId]-cxf-endpoint" streamCache="true">
            <from uri="direct-vm:call-[=objectId]-service" />
         <!--   <setHeader name="ENTAXY_EndpointName">
                <simple>[=objectId]</simple>
            </setHeader> -->
            
            <to uri="direct:[=objectId]-operation-router" />
            
            <to uri="cxf:bean:[=objectId]-cxf-endpoint[=utils.createQueryString(properties, "camel_", true, ["fieldToExclude1","fieldToExclude2"])]"/>
        </route>

    </camelContext>

</blueprint> 
