/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-atlasmap-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
/**
 * The main entry point for the Simple module
 */
var EntaxyAtlasmap = (function (EntaxyAtlasmap) {

    /**
     * The name of this plugin
     */
    EntaxyAtlasmap.pluginName = 'entaxy-atlasmap';

    /**
     * This plugin's logger instance
     */
    EntaxyAtlasmap.log = Logger.get('entaxy-atlasmap');

    /**
     * The top level path of this plugin on the server
     */
    EntaxyAtlasmap.contextPath = "/entaxy-atlasmap/";

    EntaxyAtlasmap.log.info("loading entaxy atlasmap plugin")
    EntaxyAtlasmap._module = angular.module(EntaxyAtlasmap.pluginName, [
        'angularResizable'
    ])
    .config(configureRoutes)
    .run(configurePlugin);

    function configureRoutes($routeProvider) {
        'ngInject';
        $routeProvider.when('/entaxy-transformation', {template: '<entaxy-atlasmap-console></entaxy-atlasmap-console>'});
    }
    configureRoutes.$inject = ['$routeProvider'];

    function configurePlugin(mainNavService, workspace, helpRegistry, preferencesRegistry, localStorage, preLogoutTasks, documentBase, $templateCache, jolokia) {
        var entaxyAtlasmapJmxDomain = localStorage['entaxyAtlasmapJmxDomain'] || "ru.entaxy.atlasmap";
        mainNavService.addItem({
            title: 'Entaxy Transformation',
            href: '/entaxy-transformation',
            isValid: function () { return workspace.treeContainsDomainAndProperties(entaxyAtlasmapJmxDomain); },
            rank: 1
        });

        // clean up local storage upon logout
        /*        preLogoutTasks.addTask('CleanupArtemisCredentials', function () {
                    Artemis.log.debug("Clean up Artemis credentials in local storage");
                    localStorage.removeItem('artemisUserName');
                    localStorage.removeItem('artemisPassword');
                }); */
    }
    configurePlugin.$inject = ['mainNavService', 'workspace', 'helpRegistry', 'preferencesRegistry', 'localStorage', 'preLogoutTasks', 'documentBase', '$templateCache', 'jolokia'];

    return EntaxyAtlasmap;

})(EntaxyAtlasmap || {});

// tell the Hawtio plugin loader about our plugin so it can be
// bootstrapped with the rest of AngularJS
hawtioPluginLoader.addModule(EntaxyAtlasmap.pluginName);
