/*-
 * ~~~~~~licensing~~~~~~
 * data-mapper-shell
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.modules.datamapper.shell;

import org.apache.karaf.shell.api.action.Command;
import org.apache.karaf.shell.api.action.Option;
import org.apache.karaf.shell.api.action.lifecycle.Service;

@Service
@Command(name = "data-mapper-resolve", scope = AbstractDataMapperCommand.COMMAND_SCOPE)
public class ResolveValueCommand extends AbstractDataMapperAwareCommand {

    @Option(name = "-d", aliases = {"--data-map"}, required = true)
    String mapName;

    @Option(name = "-k", aliases = {"--mapped-key"}, required = true)
    String mappedKey;

    @Option(name = "-t", aliases = {"--trim-for-string"}, required = true)
    boolean isTrimForString;

    @Override
    protected void doExecute() throws Exception {

        Object data = dataMapper.getMapValue(mapName, mappedKey, isTrimForString);

        // output
        if (data == null) {
            System.out.println("type: null\nvalue: null");
        } else {
            System.out.println("type: " + data.getClass().getName() + "\nvalue: " + data.toString());
        }

    }

}
