<?xml version="1.0" encoding="UTF-8" ?>
<xsl:transform xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://v8.1c.ru/8.1/data/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
    <xsl:output method="xml" omit-xml-declaration="yes" encoding="UTF-8" indent="yes" />

    <xsl:template match="/">
        <xsl:apply-templates select="child::node()"/>
    </xsl:template>

    <xsl:template match="//*:Value/*:Value[@xsi:type = 'Structure']/*[@isProperty='true']" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
        <xsl:for-each select=".">
            <Property name="{name()}">
                <xsl:apply-templates/>
            </Property>
        </xsl:for-each>
    </xsl:template>

    <xsl:template match="//*:Structure/*[@isProperty='true']">
        <xsl:for-each select=".">
            <Property name="{name()}">
                <xsl:apply-templates/>
            </Property>
        </xsl:for-each>
    </xsl:template>

    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>
</xsl:transform>

