/*-
 * ~~~~~~licensing~~~~~~
 * keystore-management
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.security.keystore.management.impl;

import javax.management.NotCompliantMBeanException;

import ru.entaxy.esb.platform.base.management.core.api.EntaxyRuntimeTyped;
import ru.entaxy.platform.core.management.object.ObjectMBean;
import ru.entaxy.platform.objects.runtime.EntaxyRuntimeObject;
import ru.entaxy.security.keystore.management.JWKKeystoreMBean;
import ru.entaxy.security.keystore.management.KeystoresMBean;
import ru.entaxy.security.keystore.runtime.KeystoreManager;

@EntaxyRuntimeTyped(name = KeystoresMBean.KEYSTORE_RUNTIME_TYPE)
@ObjectMBean(subQualifierName = "keystore")
public class JWKKeystoreMBeanImpl extends KeystoreMBeanImpl<JWKKeystoreMBean> implements JWKKeystoreMBean {

    public JWKKeystoreMBeanImpl(EntaxyRuntimeObject entaxyRuntimeObject) throws NotCompliantMBeanException {
        super(JWKKeystoreMBean.class, entaxyRuntimeObject);
    }

    public JWKKeystoreMBeanImpl(EntaxyRuntimeObject entaxyRuntimeObject, KeystoreManager keystoreManager)
            throws NotCompliantMBeanException {
        super(JWKKeystoreMBean.class, entaxyRuntimeObject, keystoreManager);
    }

    @Override
    public void addKey(String alias, String keyContent) throws Exception {
        keystoreManager.addKey(getObjectId(), alias, keyContent);
    }

    @Override
    public void removeKey(String alias) throws Exception {
        keystoreManager.removeKey(getObjectId(), alias);
    }

}
