/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
/**
 * The main entry point for the Simple module
 */
var EntaxyCICD = (function (EntaxyCICD) {

    /**
     * The name of this plugin
     */
    EntaxyCICD.pluginName = 'entaxy-cicd';

    /**
     * This plugin's logger instance
     */
    EntaxyCICD.log = Logger.get('entaxy-cicd');

    /**
     * The top level path of this plugin on the server
     */
    EntaxyCICD.contextPath = "/entaxy-cicd/";

    EntaxyCICD.log.info("loading entaxy cicd plugin")
    EntaxyCICD._module = angular.module(EntaxyCICD.pluginName, [
        'angularResizable'
    ])
    .component('entaxyCiCd', {
        template:
        `
            <div class="tree-nav-layout">
                <div class="sidebar-pf sidebar-pf-left" resizable r-directions="['right']">
                  <entaxy-ci-cd-tree-header></entaxy-ci-cd-tree-header>
                  <entaxy-ci-cd-tree></entaxy-ci-cd-tree>
                </div>
                <div class="tree-nav-main">
                  <entaxy-ci-cd-navigation></entaxy-ci-cd-navigation>
                  <entaxy-ci-cd-contents></entaxy-ci-cd-contents>
                </div>
           </div>
        `
    })
    .run(configurePlugin);

    function configurePlugin(mainNavService, workspace, helpRegistry, preferencesRegistry, localStorage) {

        var entaxyCICDJmxDomain = localStorage['entaxyCICDJmxDomain'] || "ru.entaxy.cicd";
        mainNavService.addItem({
            title: 'Entaxy CI/CD',
            basePath: '/entaxy-cicd',
            template: '<entaxy-ci-cd></entaxy-ci-cd>',
            isValid: function () { return workspace.treeContainsDomainAndProperties(entaxyCICDJmxDomain); },
            rank: 2
        });

        // clean up local storage upon logout
        /*        preLogoutTasks.addTask('CleanupArtemisCredentials', function () {
                    Artemis.log.debug("Clean up Artemis credentials in local storage");
                    localStorage.removeItem('artemisUserName');
                    localStorage.removeItem('artemisPassword');
                }); */
    }
    configurePlugin.$inject = ['mainNavService', 'workspace', 'helpRegistry', 'preferencesRegistry', 'localStorage'];

    return EntaxyCICD;

})(EntaxyCICD || {});

// tell the Hawtio plugin loader about our plugin so it can be
// bootstrapped with the rest of AngularJS
hawtioPluginLoader.addModule(EntaxyCICD.pluginName);
