/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module.component('entaxyCopyToClipboardButton', {
        bindings: {
            title: '@',
            textToCopy: '<'
        },
        template:
        `
          <button type="button" class="btn-clipboard" data-toggle="tooltip" title="{{$ctrl.title}}"
                    ng-click="$ctrl.copyLocationToClipboard($ctrl.textToCopy)">
            <span class="fa fa-copy"></span>
          </button>
        `,
        controller: entaxyCopyToClipboardButtonController
    })
    .name;

    function entaxyCopyToClipboardButtonController($timeout) {
        'ngInject';

        let ctrl = this;

        ctrl.copyLocationToClipboard = function(textToCopy) {
            let clipboard = new ClipboardJS('.btn-clipboard', {
                text: (trigger) => textToCopy
            });
            setTimeout(() => clipboard.destroy(), 1000);
        }
    }
    entaxyCopyToClipboardButtonController.$inject = ['$timeout'];

})(Entaxy || (Entaxy = {}));
