/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module.component('entaxyOperationTableRequestModal', {
        bindings: {
            modalInstance: '<',
            resolve: '<'
        },
        template:
        `
          <div class="entaxy-modal-container simple-modal-content operation-table-request-modal">
            <div class="modal-header">
              <button type="button" class="close" aria-label="Close" ng-click="$ctrl.cancel()">
                <span class="pficon pficon-close" aria-hidden="true"></span>
              </button>
              <h4 class="modal-title">{{$ctrl.modalTitle}}</h4>
            </div>
            <div class="modal-body">
              <p>{{$ctrl.message}}</p>
              <div class="operation-affected-table-container">
                <entaxy-operation-affected-table items="$ctrl.affectedObjects"></entaxy-operation-affected-table>
              </div>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-default" ng-click="$ctrl.cancel()">Cancel</button>
              <button type="button" class="btn btn-primary" ng-click="$ctrl.apply('current')">Apply only to current</button>
              <button type="button" class="btn btn-primary" ng-click="$ctrl.apply('all')">Apply to all</button>
            </div>
          </div>
        `,
        controller: entaxyOperationTableRequestModalController
    })
    .name;

    function entaxyOperationTableRequestModalController($uibModal) {
        'ngInject';

        let ctrl = this;

        ctrl.$onInit = function() {
            ctrl.operationType = ctrl.resolve.operationType.toUpperCase();

            ctrl.modalTitle = 'Confirm operation ' + ctrl.operationType;
            ctrl.message = 'To execute operation ' + ctrl.operationType + ' on '
                + ctrl.resolve.objectDisplayName + ' [' + ctrl.resolve.objectFullId + '] '
                + 'corresponding operations should be applied to the following affected objects:';

            ctrl.affectedObjects = ctrl.resolve.affectedObjects;
        }

        ctrl.cancel = function(reason) {
            ctrl.modalInstance.dismiss(reason);
        }

        ctrl.apply = function (flag) {
            ctrl.modalInstance.close(flag);
        }

    }
    entaxyOperationTableRequestModalController.$inject = ['$uibModal'];

})(Entaxy || (Entaxy = {}));
