/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module.component('entaxyConnectorBlock', {
        transclude: true,
        bindings: {
            direction: '<',
            connector: '<',
            editConnectorPropertiesFn: '<',
            saveConnectorFn: '<'
        },
        template:
        `
          <div class="connector-block" ng-class="{'has-changes': $ctrl.connector.isChanged}"
                ng-click="$ctrl.editConnectorPropertiesFn($ctrl.connector, $event)">
            <div class="connector-info">
              <div class="connector-title-container">
                <span class="profile-diagram-support-span" ng-if="$ctrl.connector.isChanged"></span>
                <span class="bold connector-title" data-toggle="tooltip" title="{{$ctrl.connector.displayName}}">
                  {{$ctrl.connector.displayName}}
                </span>
                <span class="pficon pficon-save" ng-click="$ctrl.saveConnectorFn($ctrl.connector, $event)"
                      data-toggle="tooltip" title="Save connector changes" ng-if="$ctrl.connector.isChanged"></span>
              </div>
              <span class="connector-classifier">{{$ctrl.connector.classifier}}</span>
            </div>
            <ng-transclude></ng-transclude>
          </div>
        `
    })
    .name;

})(Entaxy || (Entaxy = {}));
