/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module.component('entaxyCustomConnectorBlock', {
        transclude: true,
        bindings: {
            direction: '<',
            connector: '<',
            editConnectorPropertiesFn: '<',
            saveConnectorFn: '<',
            editConnectorCustomizationPointFn: '<'
        },
        template:
        `
          <entaxy-connector-block direction="$ctrl.direction" connector="$ctrl.connector"
                edit-connector-properties-fn="$ctrl.editConnectorPropertiesFn"
                save-connector-fn="$ctrl.saveConnectorFn">
            <div class="custom-connector-customization-points-container" ng-if="$ctrl.connector.isCustom">
              <div id="{{$ctrl.connector.name}}_{{$ctrl.customConnectorCustomizationPoints[0]}}"
                    class="customization-point-block"
                    ng-click="$ctrl.editConnectorCustomizationPointFn($ctrl.connector, $ctrl.customConnectorCustomizationPoints[0], $event)">
                {{$ctrl.customConnectorCustomizationPoints[0]}}
              </div>
              <div id="{{$ctrl.connector.name}}_{{$ctrl.customConnectorCustomizationPoints[1]}}"
                    class="customization-point-block"
                    ng-click="$ctrl.editConnectorCustomizationPointFn($ctrl.connector, $ctrl.customConnectorCustomizationPoints[1], $event)">
                {{$ctrl.customConnectorCustomizationPoints[1]}}
              </div>
            </div>
            <div id="{{$ctrl.connector.name}}_{{$ctrl.customConnectorCustomizationPoints[2]}}"
                  class="customization-point-block" ng-if="$ctrl.connector.isCustom"
                  ng-click="$ctrl.editConnectorCustomizationPointFn($ctrl.connector, $ctrl.customConnectorCustomizationPoints[2], $event)">
              {{$ctrl.customConnectorCustomizationPoints[2]}}
            </div>
          </entaxy-connector-block>
        `,
        controller: entaxyCustomConnectorBlockController
    })
    .name;

    function entaxyCustomConnectorBlockController() {
        let ctrl = this;

        ctrl.$onInit = function() {
            ctrl.customConnectorCustomizationPoints = ctrl.direction === 'in' ?
                ['custom-route', 'pre-route', 'response'] : ['custom-route', 'pre-output', 'postprocess'];
        }
    }

})(Entaxy || (Entaxy = {}));
