/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module.component('entaxyOutFlowBlock', {
        bindings: {
            editProfilePropertiesFn: '<',
            editFlowCustomizationPointFn: '<'
        },
        template:
        `
          <entaxy-flow-block direction="$ctrl.direction" flow-name="$ctrl.flowName"
                edit-profile-properties-fn="$ctrl.editProfilePropertiesFn">
            <div class="{{$ctrl.direction}}-flow-customization-points-container">
              <div id="{{$ctrl.direction}}-flow_{{$ctrl.connectorSelector}}"
                    class="customization-point-block {{$ctrl.connectorSelector}}"
                    ng-click="$ctrl.editFlowCustomizationPointFn($ctrl.connectorSelector, $event)"
                    data-toggle="tooltip" title="{{$ctrl.connectorSelector}}">
                <span class="{{$ctrl.connectorSelector}}-icon"></span>
              </div>
              <div id="{{$ctrl.direction}}-flow_{{$ctrl.preRoute}}"
                    class="customization-point-block {{$ctrl.preRoute}}"
                    ng-click="$ctrl.editFlowCustomizationPointFn($ctrl.preRoute, $event)">
                {{$ctrl.preRoute}}
              </div>
            </div>
            <div id="{{$ctrl.direction}}-flow_{{$ctrl.postprocess}}"
                  class="customization-point-block"
                  ng-click="$ctrl.editFlowCustomizationPointFn($ctrl.postprocess, $event)">
              {{$ctrl.postprocess}}
            </div>
          </entaxy-flow-block>
        `,
        controller: entaxyOutFlowBlockController
    })
    .name;

    function entaxyOutFlowBlockController() {
        let ctrl = this;

        ctrl.$onInit = function() {
            ctrl.direction = 'out';
            ctrl.flowName = 'OUT-FLOW';
            ctrl.connectorSelector = 'connector-selector';
            ctrl.preRoute = 'pre-route';
            ctrl.postprocess = 'postprocess';
        }
    }

})(Entaxy || (Entaxy = {}));
