/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {

    function getSaveHotkeyDescription() {
        return {
            combo: 'ctrl+s',
            description: 'Saves the current object',
            allowIn: ['INPUT', 'SELECT', 'TEXTAREA']
        };
    }
    Entaxy.getSaveHotkeyDescription = getSaveHotkeyDescription;

    function getSaveAsHotkeyDescription() {
        return {
            combo: 'ctrl+shift+s',
            description: 'Saves the current object with different name',
            allowIn: ['INPUT', 'SELECT', 'TEXTAREA']
        };
    }
    Entaxy.getSaveAsHotkeyDescription = getSaveAsHotkeyDescription;

    function getSaveAllHotkeyDescription() {
        return {
            combo: 'ctrl+shift+s',
            description: 'Saves the current and related objects',
            allowIn: ['INPUT', 'SELECT', 'TEXTAREA']
        };
    }
    Entaxy.getSaveAllHotkeyDescription = getSaveAllHotkeyDescription;

    function getBackHotkeyDescription() {
        return {
            combo: 'alt+left',
            description: 'Moves to the previous step of the modal',
            allowIn: ['INPUT', 'SELECT', 'TEXTAREA']
        };
    }
    Entaxy.getBackHotkeyDescription = getBackHotkeyDescription;

    function getNextHotkeyDescription() {
        return {
            combo: 'alt+right',
            description: 'Moves to the next step of the modal',
            allowIn: ['INPUT', 'SELECT', 'TEXTAREA']
        };
    }
    Entaxy.getNextHotkeyDescription = getNextHotkeyDescription;

    function getCopyHotkeyDescription() {
        return {
            combo: 'ctrl+c',
            description: 'Copies the item'
        };
    }
    Entaxy.getCopyHotkeyDescription = getCopyHotkeyDescription;

    function getCutHotkeyDescription() {
        return {
            combo: 'ctrl+x',
            description: 'Cuts the item'
        };
    }
    Entaxy.getCutHotkeyDescription = getCutHotkeyDescription;

    function getPasteHotkeyDescription() {
        return {
            combo: 'ctrl+v',
            description: 'Pastes the item'
        };
    }
    Entaxy.getPasteHotkeyDescription = getPasteHotkeyDescription;

    function getRemoveHotkeyDescription() {
        return {
            combo: 'del',
            description: 'Removes the item'
        };
    }
    Entaxy.getRemoveHotkeyDescription = getRemoveHotkeyDescription;

})(Entaxy || (Entaxy = {}));
