/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */

var Entaxy;
(function (Entaxy) {
    Entaxy._module.factory('entaxyAttributesCacheService', ['jolokia',
        function(jolokia) {
            let attributesCache = {};

            return {
                getAttributes: function (mbeanName) {
                    return getAttributes(mbeanName);
                },
                setToUpdate: function (mbeanName) {
                    return setToUpdate(mbeanName);
                },
                removeFromCache: function (mbeanName) {
                    return removeFromCache(mbeanName);
                }
            };

            function getAttributes(mbeanName) {
                let attributesCacheItem = attributesCache[mbeanName];
                if (attributesCacheItem) {
                    if (attributesCacheItem.toUpdate) {
                        let attributes = jolokia.getAttribute(mbeanName);
                        attributesCacheItem.attributes = attributes;
                        attributesCacheItem.toUpdate = false;
                    }
                    return attributesCacheItem.attributes;
                } else {
                    let attributes = jolokia.getAttribute(mbeanName);
                    attributesCache[mbeanName] = { attributes: attributes };
                    return attributes;
                }
            }

            function setToUpdate(mbeanName) {
                let attributesCacheItem = attributesCache[mbeanName];
                if (attributesCacheItem) {
                    attributesCacheItem.toUpdate = true;
                }
            }

            function removeFromCache(mbeanName) {
                delete attributesCache[mbeanName];
            }
        }
    ])
})(Entaxy || (Entaxy = {}));
